Loading...
Searching...
No Matches
her2k: Hermitian rank 2k update
Batched LA » MAGMA BLAS and Auxiliary » Level 3: matrix-matrix operations, O(n^3) work

\(C = \alpha A B^T + \alpha B A^T + \beta C\) where \(C\) is Hermitian More...

## Functions

void | magmablas_cher2k_batched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magmaFloatComplex alpha, magmaFloatComplex const *const *dA_array, magma_int_t ldda, magmaFloatComplex const *const *dB_array, magma_int_t lddb, float beta, magmaFloatComplex **dC_array, magma_int_t lddc, magma_int_t batchCount, magma_queue_t queue)
| CHER2K performs one of the Hermitian rank 2k operations.
void | magmablas_cher2k_vbatched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t *n, magma_int_t *k, magmaFloatComplex alpha, magmaFloatComplex const *const *dA_array, magma_int_t *ldda, magmaFloatComplex const *const *dB_array, magma_int_t *lddb, float beta, magmaFloatComplex **dC_array, magma_int_t *lddc, magma_int_t batchCount, magma_queue_t queue)
| CHER2K performs one of the Hermitian rank 2k operations.
void | magmablas_dsyr2k_batched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, double alpha, double const *const *dA_array, magma_int_t ldda, double const *const *dB_array, magma_int_t lddb, double beta, double **dC_array, magma_int_t lddc, magma_int_t batchCount, magma_queue_t queue)
| DSYR2K performs one of the symmetric rank 2k operations.
void | magmablas_dsyr2k_vbatched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t *n, magma_int_t *k, double alpha, double const *const *dA_array, magma_int_t *ldda, double const *const *dB_array, magma_int_t *lddb, double beta, double **dC_array, magma_int_t *lddc, magma_int_t batchCount, magma_queue_t queue)
| DSYR2K performs one of the symmetric rank 2k operations.
void | magmablas_ssyr2k_batched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, float alpha, float const *const *dA_array, magma_int_t ldda, float const *const *dB_array, magma_int_t lddb, float beta, float **dC_array, magma_int_t lddc, magma_int_t batchCount, magma_queue_t queue)
| SSYR2K performs one of the symmetric rank 2k operations.
void | magmablas_ssyr2k_vbatched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t *n, magma_int_t *k, float alpha, float const *const *dA_array, magma_int_t *ldda, float const *const *dB_array, magma_int_t *lddb, float beta, float **dC_array, magma_int_t *lddc, magma_int_t batchCount, magma_queue_t queue)
| SSYR2K performs one of the symmetric rank 2k operations.
void | magmablas_zher2k_batched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t n, magma_int_t k, magmaDoubleComplex alpha, magmaDoubleComplex const *const *dA_array, magma_int_t ldda, magmaDoubleComplex const *const *dB_array, magma_int_t lddb, double beta, magmaDoubleComplex **dC_array, magma_int_t lddc, magma_int_t batchCount, magma_queue_t queue)
| ZHER2K performs one of the Hermitian rank 2k operations.
void | magmablas_zher2k_vbatched (magma_uplo_t uplo, magma_trans_t trans, magma_int_t *n, magma_int_t *k, magmaDoubleComplex alpha, magmaDoubleComplex const *const *dA_array, magma_int_t *ldda, magmaDoubleComplex const *const *dB_array, magma_int_t *lddb, double beta, magmaDoubleComplex **dC_array, magma_int_t *lddc, magma_int_t batchCount, magma_queue_t queue)
| ZHER2K performs one of the Hermitian rank 2k operations.

## Detailed Description

\(C = \alpha A B^T + \alpha B A^T + \beta C\) where \(C\) is Hermitian

## Function Documentation

## magmablas_cher2k_batched()

void magmablas_cher2k_batched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaFloatComplex | alpha,
|  | magmaFloatComplex const *const * | dA_array,
|  | magma_int_t | ldda,
|  | magmaFloatComplex const *const * | dB_array,
|  | magma_int_t | lddb,
|  | float | beta,
|  | magmaFloatComplex ** | dC_array,
|  | magma_int_t | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

CHER2K performs one of the Hermitian rank 2k operations.

    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n Hermitian matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

## Parameters

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = Magma_ConjTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

  [in] | n | INTEGER. On entry, N specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with TRANS = MagmaNoTrans, k specifies the number of columns of the matrices A and B, and on entry with TRANS = Magma_ConjTrans, k specifies the number of rows of the matrices A and B. k must be at least zero.
  [in] | alpha | COMPLEX. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a COMPLEX array of DIMENSION ( ldda, ka ), where ka is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array A must contain the matrix A, otherwise the leading k by n part of the array A must contain the matrix A.
  [in] | ldda | INTEGER. On entry, ldda specifies the first dimension of A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then ldda must be at least max( 1, n ), otherwise ldda must be at least max( 1, k ).
  [in] | dB_array | Array of pointers, dimension (batchCount). Each is a COMPLEX array of DIMENSION ( ldb, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.
  [in] | lddb | INTEGER On entry, lddb specifies the first dimension of B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then lddb must be at least max( 1, n ), otherwise lddb must be at least max( 1, k ). Unchanged on exit.
  [in] | beta | REAL. On entry, BETA specifies the scalar beta.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is COMPLEX array of DIMENSION ( lddc, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the Hermitian matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the Hermitian matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | INTEGER. On entry, lddc specifies the first dimension of each array C as declared in the calling (sub) program. lddc must be at least max( 1, n ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_cher2k_vbatched()

void magmablas_cher2k_vbatched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t * | n,
|  | magma_int_t * | k,
|  | magmaFloatComplex | alpha,
|  | magmaFloatComplex const *const * | dA_array,
|  | magma_int_t * | ldda,
|  | magmaFloatComplex const *const * | dB_array,
|  | magma_int_t * | lddb,
|  | float | beta,
|  | magmaFloatComplex ** | dC_array,
|  | magma_int_t * | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

CHER2K performs one of the Hermitian rank 2k operations.

    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n Hermitian matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

## Parameters

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = Magma_ConjTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

  [in] | n | Array of integers, size(batchCount + 1). On entry, each INTEGER N specifies the order of the corresponding matrix C. N must be at least zero. The last element of the array is used internally by the routine.
  [in] | k | Array of integers, size(batchCount + 1). On entry with TRANS = MagmaNoTrans, each INTEGER K specifies the number of columns of the corresponding matrices A and B, and on entry with TRANS = Magma_ConjTrans, K specifies the number of rows of the corresponding matrices A and B. K must be at least zero. The last element of the array is used internally by the routine.
  [in] | alpha | COMPLEX. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a COMPLEX array of DIMENSION ( LDDA, Ka ), where Ka is K when TRANS = MagmaNoTrans, and is N otherwise. Before entry with TRANS = MagmaNoTrans, the leading N by K part of the array A must contain the matrix A, otherwise the leading K by N part of the array A must contain the matrix A.
  [in] | ldda | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDA specifies the first dimension of the corresponding matrix A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDDA must be at least max( 1, N ), otherwise LDDA must be at least max( 1, K ). The last element of the array is used internally by the routine.
  [in] | dB_array | Array of pointers, dimension (batchCount). Each is a COMPLEX array of DIMENSION ( ldb, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.
  [in] | lddb | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDB specifies the first dimension of the corresponding matrix B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDDB must be at least max( 1, N ), otherwise LDDB must be at least max( 1, K ). Unchanged on exit. The last element of the array is used internally by the routine.
  [in] | beta | REAL. On entry, BETA specifies the scalar beta.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is COMPLEX array of DIMENSION ( lddc, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the Hermitian matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the Hermitian matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDC specifies the first dimension of the corresponding matrix C as declared in the calling (sub) program. LDDC must be at least max( 1, N ). The last element of the array is used internally by the routine.
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_dsyr2k_batched()

void magmablas_dsyr2k_batched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | double | alpha,
|  | double const *const * | dA_array,
|  | magma_int_t | ldda,
|  | double const *const * | dB_array,
|  | magma_int_t | lddb,
|  | double | beta,
|  | double ** | dC_array,
|  | magma_int_t | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

DSYR2K performs one of the symmetric rank 2k operations.

    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n symmetric matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

## Parameters

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = MagmaTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

  [in] | n | INTEGER. On entry, N specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with TRANS = MagmaNoTrans, k specifies the number of columns of the matrices A and B, and on entry with TRANS = MagmaTrans, k specifies the number of rows of the matrices A and B. k must be at least zero.
  [in] | alpha | DOUBLE PRECISION. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a DOUBLE PRECISION array of DIMENSION ( ldda, ka ), where ka is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array A must contain the matrix A, otherwise the leading k by n part of the array A must contain the matrix A.
  [in] | ldda | INTEGER. On entry, ldda specifies the first dimension of A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then ldda must be at least max( 1, n ), otherwise ldda must be at least max( 1, k ).
  [in] | dB_array | Array of pointers, dimension (batchCount). Each is a DOUBLE PRECISION array of DIMENSION ( ldb, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.
  [in] | lddb | INTEGER On entry, lddb specifies the first dimension of B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then lddb must be at least max( 1, n ), otherwise lddb must be at least max( 1, k ). Unchanged on exit.
  [in] | beta | DOUBLE PRECISION. On entry, BETA specifies the scalar beta.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is DOUBLE PRECISION array of DIMENSION ( lddc, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | INTEGER. On entry, lddc specifies the first dimension of each array C as declared in the calling (sub) program. lddc must be at least max( 1, n ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_dsyr2k_vbatched()

void magmablas_dsyr2k_vbatched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t * | n,
|  | magma_int_t * | k,
|  | double | alpha,
|  | double const *const * | dA_array,
|  | magma_int_t * | ldda,
|  | double const *const * | dB_array,
|  | magma_int_t * | lddb,
|  | double | beta,
|  | double ** | dC_array,
|  | magma_int_t * | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

DSYR2K performs one of the symmetric rank 2k operations.

    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n symmetric matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

## Parameters

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = MagmaTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

  [in] | n | Array of integers, size(batchCount + 1). On entry, each INTEGER N specifies the order of the corresponding matrix C. N must be at least zero. The last element of the array is used internally by the routine.
  [in] | k | Array of integers, size(batchCount + 1). On entry with TRANS = MagmaNoTrans, each INTEGER K specifies the number of columns of the corresponding matrices A and B, and on entry with TRANS = MagmaTrans, K specifies the number of rows of the corresponding matrices A and B. K must be at least zero. The last element of the array is used internally by the routine.
  [in] | alpha | DOUBLE PRECISION. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a DOUBLE PRECISION array of DIMENSION ( LDDA, Ka ), where Ka is K when TRANS = MagmaNoTrans, and is N otherwise. Before entry with TRANS = MagmaNoTrans, the leading N by K part of the array A must contain the matrix A, otherwise the leading K by N part of the array A must contain the matrix A.
  [in] | ldda | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDA specifies the first dimension of the corresponding matrix A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDDA must be at least max( 1, N ), otherwise LDDA must be at least max( 1, K ). The last element of the array is used internally by the routine.
  [in] | dB_array | Array of pointers, dimension (batchCount). Each is a DOUBLE PRECISION array of DIMENSION ( ldb, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.
  [in] | lddb | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDB specifies the first dimension of the corresponding matrix B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDDB must be at least max( 1, N ), otherwise LDDB must be at least max( 1, K ). Unchanged on exit. The last element of the array is used internally by the routine.
  [in] | beta | DOUBLE PRECISION. On entry, BETA specifies the scalar beta.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is DOUBLE PRECISION array of DIMENSION ( lddc, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDC specifies the first dimension of the corresponding matrix C as declared in the calling (sub) program. LDDC must be at least max( 1, N ). The last element of the array is used internally by the routine.
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_ssyr2k_batched()

void magmablas_ssyr2k_batched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | float | alpha,
|  | float const *const * | dA_array,
|  | magma_int_t | ldda,
|  | float const *const * | dB_array,
|  | magma_int_t | lddb,
|  | float | beta,
|  | float ** | dC_array,
|  | magma_int_t | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

SSYR2K performs one of the symmetric rank 2k operations.

    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n symmetric matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

## Parameters

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = MagmaTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

  [in] | n | INTEGER. On entry, N specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with TRANS = MagmaNoTrans, k specifies the number of columns of the matrices A and B, and on entry with TRANS = MagmaTrans, k specifies the number of rows of the matrices A and B. k must be at least zero.
  [in] | alpha | REAL. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a REAL array of DIMENSION ( ldda, ka ), where ka is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array A must contain the matrix A, otherwise the leading k by n part of the array A must contain the matrix A.
  [in] | ldda | INTEGER. On entry, ldda specifies the first dimension of A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then ldda must be at least max( 1, n ), otherwise ldda must be at least max( 1, k ).
  [in] | dB_array | Array of pointers, dimension (batchCount). Each is a REAL array of DIMENSION ( ldb, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.
  [in] | lddb | INTEGER On entry, lddb specifies the first dimension of B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then lddb must be at least max( 1, n ), otherwise lddb must be at least max( 1, k ). Unchanged on exit.
  [in] | beta | REAL. On entry, BETA specifies the scalar beta.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is REAL array of DIMENSION ( lddc, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | INTEGER. On entry, lddc specifies the first dimension of each array C as declared in the calling (sub) program. lddc must be at least max( 1, n ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_ssyr2k_vbatched()

void magmablas_ssyr2k_vbatched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t * | n,
|  | magma_int_t * | k,
|  | float | alpha,
|  | float const *const * | dA_array,
|  | magma_int_t * | ldda,
|  | float const *const * | dB_array,
|  | magma_int_t * | lddb,
|  | float | beta,
|  | float ** | dC_array,
|  | magma_int_t * | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

SSYR2K performs one of the symmetric rank 2k operations.

    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n symmetric matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

## Parameters

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = MagmaTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

  [in] | n | Array of integers, size(batchCount + 1). On entry, each INTEGER N specifies the order of the corresponding matrix C. N must be at least zero. The last element of the array is used internally by the routine.
  [in] | k | Array of integers, size(batchCount + 1). On entry with TRANS = MagmaNoTrans, each INTEGER K specifies the number of columns of the corresponding matrices A and B, and on entry with TRANS = MagmaTrans, K specifies the number of rows of the corresponding matrices A and B. K must be at least zero. The last element of the array is used internally by the routine.
  [in] | alpha | REAL. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a REAL array of DIMENSION ( LDDA, Ka ), where Ka is K when TRANS = MagmaNoTrans, and is N otherwise. Before entry with TRANS = MagmaNoTrans, the leading N by K part of the array A must contain the matrix A, otherwise the leading K by N part of the array A must contain the matrix A.
  [in] | ldda | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDA specifies the first dimension of the corresponding matrix A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDDA must be at least max( 1, N ), otherwise LDDA must be at least max( 1, K ). The last element of the array is used internally by the routine.
  [in] | dB_array | Array of pointers, dimension (batchCount). Each is a REAL array of DIMENSION ( ldb, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.
  [in] | lddb | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDB specifies the first dimension of the corresponding matrix B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDDB must be at least max( 1, N ), otherwise LDDB must be at least max( 1, K ). Unchanged on exit. The last element of the array is used internally by the routine.
  [in] | beta | REAL. On entry, BETA specifies the scalar beta.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is REAL array of DIMENSION ( lddc, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the symmetric matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the symmetric matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDC specifies the first dimension of the corresponding matrix C as declared in the calling (sub) program. LDDC must be at least max( 1, N ). The last element of the array is used internally by the routine.
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_zher2k_batched()

void magmablas_zher2k_batched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t | n,
|  | magma_int_t | k,
|  | magmaDoubleComplex | alpha,
|  | magmaDoubleComplex const *const * | dA_array,
|  | magma_int_t | ldda,
|  | magmaDoubleComplex const *const * | dB_array,
|  | magma_int_t | lddb,
|  | double | beta,
|  | magmaDoubleComplex ** | dC_array,
|  | magma_int_t | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

ZHER2K performs one of the Hermitian rank 2k operations.

    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n Hermitian matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

## Parameters

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = Magma_ConjTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

  [in] | n | INTEGER. On entry, N specifies the order of the matrix C. N must be at least zero.
  [in] | k | INTEGER. On entry with TRANS = MagmaNoTrans, k specifies the number of columns of the matrices A and B, and on entry with TRANS = Magma_ConjTrans, k specifies the number of rows of the matrices A and B. k must be at least zero.
  [in] | alpha | COMPLEX*16. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a COMPLEX*16 array of DIMENSION ( ldda, ka ), where ka is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array A must contain the matrix A, otherwise the leading k by n part of the array A must contain the matrix A.
  [in] | ldda | INTEGER. On entry, ldda specifies the first dimension of A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then ldda must be at least max( 1, n ), otherwise ldda must be at least max( 1, k ).
  [in] | dB_array | Array of pointers, dimension (batchCount). Each is a COMPLEX*16 array of DIMENSION ( ldb, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.
  [in] | lddb | INTEGER On entry, lddb specifies the first dimension of B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then lddb must be at least max( 1, n ), otherwise lddb must be at least max( 1, k ). Unchanged on exit.
  [in] | beta | DOUBLE PRECISION. On entry, BETA specifies the scalar beta.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is COMPLEX*16 array of DIMENSION ( lddc, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the Hermitian matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the Hermitian matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | INTEGER. On entry, lddc specifies the first dimension of each array C as declared in the calling (sub) program. lddc must be at least max( 1, n ).
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.

## magmablas_zher2k_vbatched()

void magmablas_zher2k_vbatched | ( | magma_uplo_t | uplo,
|  | magma_trans_t | trans,
|  | magma_int_t * | n,
|  | magma_int_t * | k,
|  | magmaDoubleComplex | alpha,
|  | magmaDoubleComplex const *const * | dA_array,
|  | magma_int_t * | ldda,
|  | magmaDoubleComplex const *const * | dB_array,
|  | magma_int_t * | lddb,
|  | double | beta,
|  | magmaDoubleComplex ** | dC_array,
|  | magma_int_t * | lddc,
|  | magma_int_t | batchCount,
|  | magma_queue_t | queue )

ZHER2K performs one of the Hermitian rank 2k operations.

    C := alpha*A*B**H + conjg( alpha )*B*A**H + beta*C,

or

    C := alpha*A**H*B + conjg( alpha )*B**H*A + beta*C,

where alpha and beta are scalars with beta real, C is an n by n Hermitian matrix and A and B are n by k matrices in the first case and k by n matrices in the second case.

## Parameters

Parameters

  [in]

  uplo

  magma_uplo_t. On entry, UPLO specifies whether the upper or lower triangular part of the array C is to be referenced as follows:
  - = MagmaUpper: Only the upper triangular part of C is to be referenced.
  - = MagmaLower: Only the lower triangular part of C is to be referenced.

  [in]

  trans

  magma_trans_t. On entry, TRANS specifies the operation to be performed as follows:
  - = MagmaNoTrans: C := alpha*A*B**H + conj( alpha )*B*A**H + beta*C.
  - = Magma_ConjTrans: C := alpha*A**H*B + conj( alpha )*B**H*A + beta*C.

  [in] | n | Array of integers, size(batchCount + 1). On entry, each INTEGER N specifies the order of the corresponding matrix C. N must be at least zero. The last element of the array is used internally by the routine.
  [in] | k | Array of integers, size(batchCount + 1). On entry with TRANS = MagmaNoTrans, each INTEGER K specifies the number of columns of the corresponding matrices A and B, and on entry with TRANS = Magma_ConjTrans, K specifies the number of rows of the corresponding matrices A and B. K must be at least zero. The last element of the array is used internally by the routine.
  [in] | alpha | COMPLEX*16. On entry, ALPHA specifies the scalar alpha.
  [in] | dA_array | Array of pointers, dimension (batchCount). Each is a COMPLEX*16 array of DIMENSION ( LDDA, Ka ), where Ka is K when TRANS = MagmaNoTrans, and is N otherwise. Before entry with TRANS = MagmaNoTrans, the leading N by K part of the array A must contain the matrix A, otherwise the leading K by N part of the array A must contain the matrix A.
  [in] | ldda | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDA specifies the first dimension of the corresponding matrix A as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDDA must be at least max( 1, N ), otherwise LDDA must be at least max( 1, K ). The last element of the array is used internally by the routine.
  [in] | dB_array | Array of pointers, dimension (batchCount). Each is a COMPLEX*16 array of DIMENSION ( ldb, kb ), where kb is k when TRANS = MagmaNoTrans, and is n otherwise. Before entry with TRANS = MagmaNoTrans, the leading n by k part of the array B must contain the matrix B, otherwise the leading k by n part of the array B must contain the matrix B.
  [in] | lddb | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDB specifies the first dimension of the corresponding matrix B as declared in the calling (sub) program. When TRANS = MagmaNoTrans then LDDB must be at least max( 1, N ), otherwise LDDB must be at least max( 1, K ). Unchanged on exit. The last element of the array is used internally by the routine.
  [in] | beta | DOUBLE PRECISION. On entry, BETA specifies the scalar beta.

  [in,out]

  dC_array

  Array of pointers, dimension (batchCount). Each is COMPLEX*16 array of DIMENSION ( lddc, n ). Before entry with UPLO = MagmaUpper, the leading n by n upper triangular part of the array C must contain the upper triangular part of the Hermitian matrix and the strictly lower triangular part of C is not referenced. On exit, the upper triangular part of the array C is overwritten by the upper triangular part of the updated matrix. Before entry with UPLO = MagmaLower, the leading n by n lower triangular part of the array C must contain the lower triangular part of the Hermitian matrix and the strictly upper triangular part of C is not referenced. On exit, the lower triangular part of the array C is overwritten by the lower triangular part of the updated matrix. Note that the imaginary parts of the diagonal elements need not be set, they are assumed to be zero, and on exit they are set to zero.

  [in] | lddc | Array of integers, size(batchCount + 1). On entry, each INTEGER LDDC specifies the first dimension of the corresponding matrix C as declared in the calling (sub) program. LDDC must be at least max( 1, N ). The last element of the array is used internally by the routine.
  [in] | batchCount | INTEGER The number of matrices to operate on.
  [in] | queue | magma_queue_t Queue to execute in.